var beesList = beesList || {};

// simplify this asap, instead of completely overriding this method just lias list instead
var oldGame_Player_reseverTransfer = Game_Player.prototype.reserveTransfer;
Game_Player.prototype.reserveTransfer = function(mapId, x, y, d, fadeType) {
	if (!$gameSwitches.value(1207)) { return oldGame_Player_reseverTransfer.call(this, mapId, x, y, d, fadeType); };
	beesList.addBlackListedMap();
    var rollMap = function() {
    do {
        var mapResult = Math.floor(Math.random() * (512 - 1)) + 1;
    } while (!beesList.checkBlacklistMaps(mapResult) || $gameMap._mapId == mapResult)
        return mapResult;
    };
	var rMap = rollMap();
	DataManager.loadRMapData(rMap);
	var waitForMap = function (mapId, x, y, d, fadeType, rMap) {
	if ($dataRMap) {
		var map = $dataRMap
		var eventArray = [];
        for (let i = 0; i < map.events.length; i++) {
            event = map.events[i]
			if (!event) { continue; };
			var eImage = event.pages[0].image
            if ((eImage.characterName == "DEV_TEST" && eImage.direction == 4 && eImage.pattern == 1 && eImage.characterIndex == 3) || (beesList.isBlacklistedName(event.name, rMap)) || (beesList.checkEventPosition(event)) || (eImage.characterName == "DW_Slimes")) {
                continue;
            };
            eventArray.push(map.events[i]);
        };
		$gameVariables._storedMapEvents = $gameVariables._storedMapEvents || [];
		var storeEvents = $gameVariables._storedMapEvents.filter((event) => event._eventId == $gameTemp._eventStore._eventId && event._mapId == $gameMap._mapId);
		var storeEvents = storeEvents[0];
		// console.log($gameVariables._storedMapEvents);
		var storeEvents = storeEvents || $gameTemp._eventStore;
		if (storeEvents.storeMap) {
			var rEvent = beesList.checkMapTps(eventArray, storeEvents.storeMap);
			beesList.checkMap(storeEvents.storeMap);
		} else {
			var rEvent = beesList.checkMapTps(eventArray, rMap);
			beesList.checkMap(rMap);
		};
        $gamePlayer._transferring = true;
        $gamePlayer._newMapId = storeEvents.storeMap ? storeEvents.storeMap : rMap;
        $gamePlayer._newX = rEvent ? beesList.checkEventHitboxX(rEvent) : map.width / 2;
        $gamePlayer._newY = rEvent ? beesList.checkEventHitboxY(rEvent) : map.height / 2;
		if (rEvent) { $gamePlayer._newY = rEvent.y + 1 >= map.height ? rEvent.y : $gamePlayer._newY };
		if (storeEvents.storeMap) {
			$gamePlayer._newX = storeEvents.storeMapX
			$gamePlayer._newY = storeEvents.storeMapY
		};
        $gamePlayer._newDirection = d;
        $gamePlayer._fadeType = fadeType;
		beesList.reEnableStuff();
		if (!storeEvents.storeMap) {
		    storeEvents.storeMap = rMap;
		    storeEvents.storeMapX = $gamePlayer._newX;
		    storeEvents.storeMapY = $gamePlayer._newY;
			$gameVariables._storedMapEvents.push(storeEvents);
		};
		var eventArray = [];
		setTimeout(function() {
		$gameTemp.reserveCommonEvent(32)
		$gameScreen.startTint([0,0,0,0], 60) 
		}, 500)
    }
    else{
        setTimeout(waitForMap, 250, mapId, x, y, d, fadeType, rMap);
    }
	};
	waitForMap(mapId, x, y, d, fadeType, rMap);
};

DataManager.loadRMapData = function(mapId) {
	if(!!Utils.isOptionValid("test")) {
        if (mapId > 0) {
            var filename = 'Map%1.json'.format(mapId.padZero(3));
            this._mapLoader = ResourceHandler.createLoader('data/' + filename, this.loadDataFile.bind(this, '$dataRMap', filename));
            this.loadDataFile('$dataRMap', filename);
        } else {
            this.makeEmptyMap();
        };
		return;
	};
	const path = require('path');
	const fs = require('fs');
	var base = path.dirname(process.mainModule.filename);
	if(mapId > 0) {
		let filename = 'Map%1.KEL'.format(mapId.padZero(3));
		this._mapLoader = false;
		window["$dataRMap"] = null;
		fs.readFile(base + "/data/" + filename, (err, buffer) => {
		if(!!err) {
			Graphics.printLoadingError(base + "/data/" + filename);
			SceneManager.stop();
		}
		let decrypt = Encryption.decrypt(buffer);
		window["$dataRMap"] = JSON.parse(decrypt.toString());
		DataManager.onLoad(window["$dataRMap"])
		this._mapLoader = true;
        });
	};
};
	
var oldDataManager_onLoad = DataManager.onLoad
DataManager.onLoad = function(object) {
        oldDataManager_onLoad.call(this, object);
        if (object === $dataRMap) {
            this.extractMetadata(object);
        };
};	
	
// Blacklisted Map List	
beesList.checkBlacklistMaps = function(mapId) {
	var invalidMapList = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 54, 77, 86, 93, 94, 188, 246, 262, 263, 299, 306, 307, 308, 319, 337, 346, 355, 360, 361, 363, 364, 365, 366, 367, 368, 369,
	375, 389, 400, 401, 411, 416, 417, 418, 419, 420, 422, 423, 424, 425, 439, 444, 461, 467, 471, 472, 473, 475, 476, 477, 478, 479, 480, 481, 482, 483, 484, 485, 486, 487, 488, 321];
	if (invalidMapList.contains(mapId) || $gameVariables._storedBlackListedMaps.contains(mapId)) { return undefined; };
	return true;
};

// Incase a certain condition is met, add map to the map blacklist
beesList.addBlackListedMap = function() {
	$gameVariables._storedBlackListedMaps = $gameVariables._storedBlackListedMaps || [];
	if (!$gameVariables._storedBlackListedMaps.contains(380) && $gameSwitches.value(189)) { $gameVariables._storedBlackListedMaps.push(380) };
	if (!$gameVariables._storedBlackListedMaps.contains(309) && $gameSwitches.value(1573)) { $gameVariables._storedBlackListedMaps.push(309) };
	if (!$gameVariables._storedBlackListedMaps.contains(388) && $gameSelfSwitches.value([388, 2, "A"])) { $gameVariables._storedBlackListedMaps.push(388) };
	if (!$gameVariables._storedBlackListedMaps.contains(324) && $gameSelfSwitches.value([324, 10, "A"])) { $gameVariables._storedBlackListedMaps.push(324) };
	if (!$gameVariables._storedBlackListedMaps.contains(323) && $gameSelfSwitches.value([323, 14, "A"])) { $gameVariables._storedBlackListedMaps.push(323) };
	if (!$gameVariables._storedBlackListedMaps.contains(322) && $gameSwitches.value(983)) { $gameVariables._storedBlackListedMaps.push(322) };
	if (!$gameVariables._storedBlackListedMaps.contains(466) && $gameSelfSwitches.value([466, 58, "A"])) { $gameVariables._storedBlackListedMaps.push(466) };
};

// Blacklisted Event Names
beesList.isBlacklistedName = function(eventName, mapId) {
	if (mapId == 390 || eventName == "KELS HOME (NIGHT)") { return false; } // hospital ending map && unused kel and hero's home night map
    var name = eventName.toLowerCase();
    var blacklistedEventNames = ["omori", "kel", "aubrey", "hero", "mari run", "mirror_effect", "forestcheck", "space bf ship", "anglerfish", "time to rock", "garden mole", "axe mole",
	"television", "aubrey_smash (9)", "butterfly", "kellogg", "aubrey (15)", "treadmill", "aubs", "conveyor-bot", "conveyor", "omphrey", "bomphrey", "omphrey2", "momphrey", "melonJamPackets",
	"fear of drowning", "mine track", "bugs", "hub: lost forest 2", "molehole", "mari's window"];
    return blacklistedEventNames.some(substring=>name.includes(substring));
};

// Check map if player should tp onto random event or not
beesList.checkMapTps = function(eventArray, mapId) {
	var mapIds = [43, 80, 111, 123, 124, 126, 168, 176, 178, 180, 183, 190, 206, 209, 223, 225, 229, 232, 250, 258, 286, 426, 429, 433, 437, 438, 462, 495, 446, 500];
    var rEventtest = eventArray.filter((eventCheck) => eventCheck.pages[0].image.characterName == "DEV_TEST" && eventCheck.pages[0].image.direction == 2 && eventCheck.pages[0].image.pattern == 1 && eventCheck.pages[0].image.characterIndex == 3);
	if (rEventtest.length == 0 || !mapIds.contains(mapId)) {
		    var rEvent = eventArray[Math.floor(Math.random() * eventArray.length)];
		} else {
			var rEvent = rEventtest[Math.floor(Math.random() * rEventtest.length)];
		};
    return rEvent;
};

//// Check if player should tp ontop of said event or not
//beesList.checkEvent = function(eventName) {
//    var name = eventName.toLowerCase();
//    var eventNames = ["statue", "dock", "raft", "swimming", "beaching", "to outskirts", "to deeper well", "to pyrefly", "to orange oasis", "to medusa maze 2", "to frozen forest"];
//    return eventNames.includes(name);
//};

// Do something neat if it's a special map + other stuff
beesList.checkMap = function(mapId) {
	if (mapId !== 218 && $gameScreen._pictures[1]) {
		if ($gameScreen._pictures[1]._name == "sgl_uvula") { $gameScreen.erasePicture(1) };
	};
	if ($gameScreen._pictures[2] && $gameScreen._pictures[2]._name == "black_screen") { $gameScreen.erasePicture(2) };
	if ($gameScreen._pictures[90] && $gameScreen._pictures[90]._name == "white_screen") { $gameScreen.erasePicture(90) };
	if ($gameScreen._pictures[1] && $gameScreen._pictures[1]._name == "horror_longsnout") { 
	$gameScreen.erasePicture(1);
	$gameSwitches.setValue(221, false);
	};
	if (mapId !== 402) { $gameSwitches.setValue(818, false) }; // turn off pizza switch
	if (mapId == 92) { $gameSwitches.setValue(1559, true) };
	if ($gameSwitches.value(41)) { $gameSwitches.setValue(41, false) }; // turn on follow ups
	// Black Key maps
	var bsKeyMaps = [506, 507, 508, 509, 510, 511, 512, 459, 464, 445, 448, 454, 303, 463, 301, 451];
	if (bsKeyMaps.contains(mapId)) {
		if (mapId == 301 && $gameSelfSwitches.value([301, 21, "B"])) { $gameSwitches.setValue(1626, true) };
		if (mapId == 451) {
			$gameSwitches.setValue(4, true);
			$gameVariables.setValue(1045, 1);
			$gameSwitches.setValue(1574, true);
			$gameTemp._catRoom = true;
		};
		var blackKeys = [8, 3, 11, 7, 4, 5, 22, 39, 46, 45, 31, 28];
		for (var i = 0; i < blackKeys.length; i++) {
			if ($gameSelfSwitches.value([mapId, blackKeys[i], "A"])) {
				$gameSwitches.setValue(1626, true);	
			};
		};
	};
	// Telescope Maps
	var telescopeMaps = [490, 491, 492, 493, 494];
	if (telescopeMaps.contains(mapId)) {
        $gameSwitches.setValue(1560, true);
   		$gameTemp._telescopeActivated = true;
	} else if (mapId == 217) {
		$gameSelfSwitches.setValue([217, 1, "A"], false);
	} else if (mapId == 452) {
		$gameSwitches.setValue(1063, true);	
	} else if (mapId == 309) {
		$gameSwitches.setValue(430, true);	
		$gameSelfSwitches.setValue([309, 1, "D"], false);
	} else if (mapId == 393) {
		if (!$gameVariables.hasGivenfaAlbum) {
		    beesList.giveAllAlbumPhotos("fa");
		};
	} else if (mapId == 318) {
		if (!$gameVariables.hasGivenbsAlbum) {
		    beesList.giveAllAlbumPhotos("bs");
		};
	} else if (mapId == 150) {
		$gameSelfSwitches.setValue([150, 23, "A"], true);
	} else if (mapId == 316) {
		$gameSelfSwitches.setValue([316, 2, "A"], false);
		$gameSelfSwitches.setValue([316, 3, "A"], false);
		$gameSelfSwitches.setValue([316, 1, "B"], false);
	} else if (mapId == 98) {
		if (!$gameVariables.hasGivendwAlbum) {
		    beesList.giveAllAlbumPhotos("dw");
		};
	} else if (mapId == 433) {
		$gameSwitches.setValue(1499, true);	
	} else if (mapId == 459) {
		$gameSelfSwitches.setValue([459, 21, "A"], true);
	} else if (mapId == 87) {
		$gameSwitches.setValue(1572, false);	
	} else if (mapId == 388) {
		$gameSelfSwitches.setValue([388, 6, "A"], false);
		$gameSelfSwitches.setValue([388, 6, "D"], false);
	} else if (mapId == 68) {
		$gameSwitches.setValue(997, true);	
	} else if (mapId == 387) {
		$gameSelfSwitches.setValue([387, 3, "A"], false);	
	} else if (mapId == 502) {
		$gameVariables.setValue(1066, 0);
	} else if (mapId == 458) {
		$gameSelfSwitches.setValue([458, 5, "C"], false);
	} else if (mapId == 381) {
		$gameSelfSwitches.setValue([381, 1, "A"], false);
	} else if (mapId == 148) {
		if (Math.randomInt(1) == 1) {
		    $gameSwitches.setValue(1610, true);
		} else {
		    $gameSwitches.setValue(1618, true);
		};
	} else if (mapId == 466) {
		$gameSelfSwitches.setValue([466, 58, "A"], false);
	} else if (mapId == 38) {
		$gameSwitches.setValue(154, true);
	};
};

// Being nice :)
beesList.giveAllAlbumPhotos = function(album) {
	switch (album) {
		case "fa":
		for (let i = 914 ; i <= 962; i++) {
			$gameParty.gainItem($dataItems[i], 1);
		};
		$gameVariables.hasGivenfaAlbum = true;
		break;
		case "bs":
		for (let i = 889 ; i <= 913; i++) {
			$gameParty.gainItem($dataItems[i], 1);
		};
		$gameVariables.hasGivenbsAlbum = true;
		break;
		case "dw":
		for (let i = 876 ; i <= 888; i++) {
			$gameParty.gainItem($dataItems[i], 1);
		};
		$gameVariables.hasGivendwAlbum = true;
		break;
		default:
		break;
	};
};

// re-enables core gameplay functions, and always allow tag shortcut
beesList.reEnableStuff = function() {
	    if ($gameSwitches.value(16)) { $gameSwitches.setValue(16, false); };
        if (!$gameSystem._menuEnabled) { $gameSystem._menuEnabled = true; };
        if ($gamePlayer.isTransparent() || $gamePlayer._opacity <= 0) {
			$gamePlayer.setTransparent(false);
			$gamePlayer.setOpacity(255);
		};
		if ($gamePlayer._moveSpeed < 4) { $gamePlayer.setMoveSpeed(4); };
		if ($gameSystem._disableDashing) { $gameSystem.setDashDisabled(false); };
		if (!$gameTemp._telescopeActivated) { $gameSwitches.setValue(1560, false); };
		if (!$gameTemp._catRoom) { $gameSwitches.setValue(1574, false); };
		if ($gameSwitches.value(237)) {
		    $gameSwitches.setValue(237, false);
		    $gameScreen.removeHorrorEffect('glitch');
		    $gameScreen.removeHorrorEffect('noise');
		};
		$gameTemp._telescopeActivated = false;
		$gameTemp._catRoom = false;
};

// Check if event is in top left of the map
beesList.checkEventPosition = function(event) {
	if (event.x == 0 && event.y <= 3) { return true };
	return false;
};

beesList.checkEventHitboxX = function(event) {
  if (event.note.match(/<Hitbox Left:[ ](\d+)>/i)) {
    return event.x - 1;
  }
  if (event.note.match(/<Hitbox Right:[ ](\d+)>/i)) {
    return event.x + 1;
  }
  return event.x;
};

beesList.checkEventHitboxY = function(event) {
  if (event.note.match(/<Hitbox Up:[ ](\d+)>/i)) {
    return event.y - 1;
  }
  if (event.note.match(/<Hitbox Down:[ ](\d+)>/i)) {
    return event.y + 1;
  }
  return event.y + 1;
};

DataManager.loadRMapData(100);

var oldGame_Player_canPass = Game_Player.prototype.canPass;
Game_Player.prototype.canPass = function(x, y, d) {
	if (!$gameSwitches.value(1207)) { return oldGame_Player_canPass.call(this, x, y, d); };
    var x2 = $gameMap.roundXWithDirection(x, d);
    var y2 = $gameMap.roundYWithDirection(y, d);
    if (!$gameMap.isValid(x2, y2)) {
        return false;
    }
    if (this.isThrough() || this.isDebugThrough()) {
        return true;
    }
    if (!this.isMapPassable(x, y, d)) {
		this.checkIfStuck(x, y, d);
        return false;
    }
    if (this.isCollidedWithCharacters(x2, y2)) {
        return false;
    }
    return true;
};

Game_Player.prototype.checkIfStuck = function(x, y, d) {
	var passable = Game_Character.prototype.isMapPassable;
    if (passable.call(this, x, y, 2) || passable.call(this, x, y, 4) || passable.call(this, x, y, 6) || passable.call(this, x, y, 8) && this.isJumping()) { return; };
    this.unstuck(x, y, d);	
};

//Old Unstuck Code
//Game_Player.prototype.unstuck = function(x, y, d) {
//	for (let i = this.y - 2; i < this.y + 3; i++) {
//		if (this.isJumping()) { break; };
//		for (let u = this.x - 2; u < this.x + 3; u++) {
//				var passable = Game_Character.prototype.isMapPassable;
//                if (passable.call(this, u, i, 2) || passable.call(this, u, i, 4) || passable.call(this, u, i, 6) || passable.call(this, u, i, 8)) {
//					if (!this.isJumping() && u >= 0) {
//						console.log("jump to " + u + " and " + i);
//					    this.jumpToPoint(u, i);
//					};
//				};
//		};
//	};
//};

Game_Player.prototype.unstuck = function(x, y, d) {
	if (!this.isJumping()) {
		var passable = Game_Character.prototype.isMapPassable;
		switch (d) {
		case 8:
		for (let i = this.y ; i >= 0; i--) {
			if (passable.call(this, this.x, i, 2) || passable.call(this, this.x, i, 4) || passable.call(this, this.x, i, 6) || passable.call(this, this.x, i, 8) && !this.isJumping()) {
				this.jumpToPoint(this.x, i);
				break;
			};
		};
		break;
		case 6:
		for (let i = this.x ; i < $dataMap.width; i++) {
			if (passable.call(this, i, this.y, 2) || passable.call(this, i, this.y, 4) || passable.call(this, i, this.y, 6) || passable.call(this, i, this.y, 8) && !this.isJumping()) {
				this.jumpToPoint(i, this.y);
				break;
			};
		};
		break;
		case 2:
		for (let i = this.y ; i < $dataMap.height; i++) {
			if (passable.call(this, this.x, i, 2) || passable.call(this, this.x, i, 4) || passable.call(this, this.x, i, 6) || passable.call(this, this.x, i, 8) && !this.isJumping()) {
				this.jumpToPoint(this.x, i);
				break;
			};
		};
		break;
		case 4:
		for (let i = this.x ; i >= 0; i--) {
			if (passable.call(this, i, this.y, 2) || passable.call(this, i, this.y, 4) || passable.call(this, i, this.y, 6) || passable.call(this, i, this.y, 8) && !this.isJumping()) {
				this.jumpToPoint(i, this.y);
				break;
			};
		};
		break;
		default:
		break;
	};
  };
};

// making it always skippable if cannot move.
var oldGame_Player_forceMoveRoute = Game_Player.prototype.forceMoveRoute;
Game_Player.prototype.forceMoveRoute = function(moveRoute) {
	if (!$gameSwitches.value(1207)) { 
	    oldGame_Player_forceMoveRoute.call(this, moveRoute);
	    return;
	};	
	moveRoute.skippable = true;
    if (!this._originalMoveRoute) {
        this.memorizeMoveRoute();
    }
    this._moveRoute = moveRoute;
    this._moveRouteIndex = 0;
    this._moveRouteForcing = true;
    this._waitCount = 0;
};

var oldGame_Character_forceMoveRoute = Game_Character.prototype.forceMoveRoute;
Game_Character.prototype.forceMoveRoute = function(moveRoute) {
	if (!$gameSwitches.value(1207)) { 
	    oldGame_Character_forceMoveRoute.call(this, moveRoute);
	    return;
	};	
	moveRoute.skippable = true;
    if (!this._originalMoveRoute) {
        this.memorizeMoveRoute();
    }
    this._moveRoute = moveRoute;
    this._moveRouteIndex = 0;
    this._moveRouteForcing = true;
    this._waitCount = 0;
};

//Move To Point Failsafe
Game_CharacterBase.prototype.moveToPoint = function(x, y, collision) {
  this._fChecks = this._fChecks || 0;
  this._fChecks++;
  this._currentX = this._currentX || this.x;
  this._currentY = this._currentY || this.y;
  if (this._currentX !== this.x || this._currentY !== this.y) {
      this._currentX = this.x;
      this._currentY = this.y;  
	  this._fChecks = 0;
  };
  collision = collision || false;
  x = Math.round(x);
  y = Math.round(y);
  if (collision) $gameTemp._moveAllowPlayerCollision = true;
  var direction = this.findDirectionTo(x, y);
  if (collision) $gameTemp._moveAllowPlayerCollision = false;
  if (direction > 0) this.moveStraight(direction);
  if (this.x !== x || this.y !== y && !this._fChecks >= 80) this._moveRouteIndex -= 1;
  if (this._fChecks >= 80) this._moveRouteIndex += 1;
  this.setMovementSuccess(true);
  if (this._fChecks >= 80) { this._fChecks = 0; };
};

var oldGame_Event_start = Game_Event.prototype.start;
Game_Event.prototype.start = function () {
	oldGame_Event_start.call(this);
	// console.log(this);
	if (!this._isAutoRunEvent) { $gameTemp._eventStore = this };
	if ((this._trigger == 3) && !this._isAutoRunEvent) {
		this._isAutoRunEvent = true;
	};
};

var oldGame_Event_updateParallel = Game_Event.prototype.updateParallel;
Game_Event.prototype.updateParallel = function () {
	oldGame_Event_updateParallel.call(this);
    if (this._interpreter && !this._isParallelEvent) {
		$gameTemp._eventStore = this;
		this._isParallelEvent = true;
	};
};